VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "NPort TCP Client Example"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7815
   LinkTopic       =   "Form1"
   ScaleHeight     =   5415
   ScaleWidth      =   7815
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtip1 
      Height          =   375
      Left            =   1680
      MaxLength       =   3
      TabIndex        =   0
      Top             =   120
      Width           =   375
   End
   Begin VB.TextBox txtip2 
      Height          =   375
      Left            =   2160
      MaxLength       =   3
      TabIndex        =   1
      Top             =   120
      Width           =   375
   End
   Begin VB.TextBox txtip3 
      Height          =   375
      Left            =   2640
      MaxLength       =   3
      TabIndex        =   2
      Top             =   120
      Width           =   375
   End
   Begin VB.TextBox txtip4 
      Height          =   375
      Left            =   3120
      MaxLength       =   3
      TabIndex        =   3
      Top             =   120
      Width           =   375
   End
   Begin VB.Timer Timer1 
      Left            =   360
      Top             =   600
   End
   Begin VB.TextBox txtCount 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1028
         SubFormatType   =   1
      EndProperty
      Height          =   405
      Left            =   5400
      MaxLength       =   2
      TabIndex        =   7
      Text            =   "1"
      Top             =   720
      Width           =   615
   End
   Begin VB.CommandButton cmdDefaultData 
      Caption         =   "Send Default Pattern"
      Height          =   375
      Left            =   1680
      TabIndex        =   6
      Top             =   720
      Width           =   1815
   End
   Begin VB.CommandButton cmddisConnect 
      Caption         =   "Disconnect"
      Height          =   375
      Left            =   6240
      TabIndex        =   10
      Top             =   720
      Width           =   1455
   End
   Begin VB.TextBox txtPort 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1028
         SubFormatType   =   1
      EndProperty
      Height          =   405
      Left            =   5400
      MaxLength       =   4
      TabIndex        =   4
      Text            =   "4001"
      Top             =   120
      Width           =   615
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   375
      Left            =   6240
      TabIndex        =   5
      Top             =   120
      Width           =   1455
   End
   Begin VB.TextBox txtRecv 
      Height          =   1815
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   9
      Top             =   3480
      Width           =   7575
   End
   Begin VB.TextBox txtSend 
      Height          =   1815
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   8
      Top             =   1320
      Width           =   7575
   End
   Begin VB.Label Label6 
      Caption         =   "E"
      Height          =   135
      Left            =   2040
      TabIndex        =   18
      Top             =   360
      Width           =   135
   End
   Begin VB.Label Label7 
      Caption         =   "E"
      Height          =   135
      Left            =   2520
      TabIndex        =   17
      Top             =   360
      Width           =   135
   End
   Begin VB.Label Label8 
      Caption         =   "E"
      Height          =   135
      Left            =   3000
      TabIndex        =   16
      Top             =   360
      Width           =   135
   End
   Begin VB.Label Label5 
      Caption         =   "Count"
      Height          =   255
      Left            =   4800
      TabIndex        =   15
      Top             =   840
      Width           =   495
   End
   Begin VB.Label Label4 
      Caption         =   "Receive Data"
      Height          =   255
      Left            =   120
      TabIndex        =   14
      Top             =   3240
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "Send Data"
      Height          =   255
      Left            =   120
      TabIndex        =   13
      Top             =   1080
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "TCP Server Port number"
      Height          =   255
      Left            =   3600
      TabIndex        =   12
      Top             =   240
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "NPort TCP Server IP"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   240
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' Project: TCP Client Example using VB
'
' Description:
'    This application contains a TCP client. The client side is simple. The
'    user specifies the host IP and port where the TCP server is running and
'    hits the connect button. This establishes a connection to the TCP server.

'    User may enter text into the send window and the text will send at once.
'    Additionally, user may enter count number to send default pattern, which
'    contains 20 bytes as "abcdefghij0123456789". When hit the button Send
'    Default Pattern, the default pattern will be sent at once.

'    If TCP Client receives some data from the connection, they will be shown
'    in the receive window.

Option Explicit

Dim tmp As Integer
Dim soc As Long, dwRc As Long
Dim RemoteAddr As sockaddr
Dim RetMsg As String
Dim hEvent As Long
Dim Selidx As Integer
' start example program and initial display
Private Sub Form_Load()
    Timer1.Enabled = False
    Timer1.Interval = 10
    If TCPIPStartup Then
        cmdConnect.Enabled = True
        cmddisConnect.Enabled = False
        cmdDefaultData.Enabled = False
        txtCount.Enabled = False
        txtSend.Enabled = False
        txtRecv.Enabled = False
    Else
        MsgBox "Windows Sockets not initialized. Error: " & Err.LastDllError
    End If
    soc = INVALID_SOCKET
    hEvent = WSACreateEvent
End Sub

Private Sub Form_Unload(Cancel As Integer)
    TCPIPShutDown
    If hEvent <> 0 Then WSACloseEvent hEvent
End Sub
' each time interval will let program enter timer routine.
Private Sub Timer1_Timer()
Dim strRecv As String
Dim retRecv As Long
    ' let the textbox curses at the end line and lastest position
    txtSend.SelStart = Len(txtSend.Text)
    txtRecv.SelStart = Len(txtRecv.Text)

    If soc = INVALID_SOCKET Then
        Debug.Print "Create Socket First"
        Exit Sub
    End If
    
    strRecv = String(1024, 0)
    ' set read socket event
    dwRc = WSAEventSelect(soc, hEvent, FD_READ)
    If (dwRc = SOCKET_ERROR) Then
        MsgBox "Failed to select event. Error: " & Err.LastDllError
        Exit Sub
    End If
    ' wait for reading event
    dwRc = WSAWaitForMultipleEvents(1, hEvent, False, 0, False)
       
    Select Case dwRc
    Case WSA_WAIT_TIMEOUT
        Debug.Print "Recv timed out"
        
    Case WSA_WAIT_EVENT_0
        Dim NetworkEvents As WSANETWORKEVENTS
        Dim dwRet As Long
        NetworkEvents.lNetWorkEvents = 0
        dwRet = WSAEnumNetworkEvents(soc, hEvent, NetworkEvents)
        If (dwRet = SOCKET_ERROR) Then
            MsgBox "WSAEnumNetworkEvents failed to select event. Error: " & Err.LastDllError
        Else
        'recv data from socket
            If (FD_READ And NetworkEvents.lNetWorkEvents) Then
                retRecv = recv(soc, ByVal strRecv, Len(strRecv), 0)
                If retRecv = SOCKET_ERROR Then
                    MsgBox "Couldn't recieve data from remote Socket. Error: " & Err.LastDllError
                    Exit Sub
                Else
        'display receive data in textbox
                    txtRecv.Text = txtRecv.Text & Left(strRecv, retRecv)
                End If
            End If
        End If
    
    Case WSA_WAIT_FAILED
        MsgBox "WSAWaitForMultipleEvents failed. Error: " & Err.LastDllError
    Case Else
        MsgBox "Unexpected WSAWaitForMultipleEvents return. Error: " & Err.LastDllError
    End Select
    
    dwRc = WSAEventSelect(soc, hEvent, 0)
    If (dwRc = SOCKET_ERROR) Then
        MsgBox "Failed to select event. Error: " & Err.LastDllError
        Exit Sub
    End If
End Sub
'when click the "conect" button, a socket will be created
'and connect to specified  TCP server.
Private Sub cmdConnect_Click()
Dim strServer As String
Dim i As Integer

    If txtip1.Text = "" Or txtip2.Text = "" Or txtip3.Text = "" Or txtip4.Text = "" Then
        MsgBox " Please enter host ip address. "
        Exit Sub
    End If
    
    If txtip1.Text > 255 Or txtip2.Text > 255 Or txtip3.Text > 255 Or txtip4.Text > 255 Then
        MsgBox " Invalid IP Address. "
        Exit Sub
    End If
    
    If txtPort.Text = "" Then
        MsgBox " Please enter host port number. "
        Exit Sub
    End If
    strServer = txtip1.Text & "." & txtip2.Text & "." & txtip3.Text & "." & txtip4.Text
    
    ' create a socket for TCP client
    soc = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)
    If soc = INVALID_SOCKET Then
        MsgBox "Couldn't Create Socket. Error: " & Err.LastDllError
    Else
        RemoteAddr.sin_family = AF_INET
        RemoteAddr.sin_port = htons(CLng(txtPort.Text))
        RemoteAddr.sin_addr = GetHostByNameAlias(strServer)
        
        'connect to TCP server
        dwRc = connect(soc, RemoteAddr, sockaddr_size)
            
        If dwRc = SOCKET_ERROR Then
            MsgBox "Couldn't connect to remote Socket. Error: " & Err.LastDllError
        Else
            cmdConnect.Enabled = False
            cmddisConnect.Enabled = True
            cmdDefaultData.Enabled = True
            txtCount.Enabled = True
            txtSend.Enabled = True
            Timer1.Enabled = True
        End If

    End If
End Sub
'when click "disconnect" button, the connection and socket will be closed
Private Sub cmddisConnect_Click()
    txtSend.Text = ""
    txtRecv.Text = ""
    If soc <> INVALID_SOCKET Then
        closesocket (soc)
        cmdConnect.Enabled = True
        cmddisConnect.Enabled = False
        cmdDefaultData.Enabled = False
        txtCount.Enabled = False
        txtSend.Enabled = False
        Timer1.Enabled = False
    End If
    soc = INVALID_SOCKET
End Sub

' as Send textbox change, this routine will occur and update Send textbox
Private Sub txtSend_Change()
Dim strSend As String
Dim chSend(0 To 1) As Byte
Dim retSend As Long
    ' catch the part of change in textbox
    If Len(txtSend.Text) > 0 Then
        strSend = txtSend.Text
        chSend(0) = Asc(Mid(strSend, Len(strSend), 1))
    Else
        Exit Sub
    End If
    ' send the data of change to socket
    retSend = send(soc, chSend(0), UBound(chSend), 0)
    If retSend = SOCKET_ERROR Then
        MsgBox "Couldn't send data to remote Socket. Error: " & Err.LastDllError
    End If
    
End Sub
' when "send default pattern" button is clicked, the default data will send to socket
Private Sub cmdDefaultData_Click()
Dim Count As Integer
Dim strSend(0 To 20) As Byte
Dim i As Long, j As Long
Dim retSend As Long
Dim strLen As Long
Dim strDefault As String
' set default data string, string length is 20
strDefault = "abcdefghij0123456789"
    
    txtSend.Enabled = False
    ' check the count value
    If txtCount.Text = "" Then
        MsgBox " Please enter send default data count. "
        txtSend.Enabled = True
        Exit Sub
    End If
    
    For i = 1 To Len(txtCount.Text)
        If Asc(Mid(txtCount.Text, i, 1)) < Asc(0) Or Asc(Mid(txtCount.Text, i, 1)) > Asc(9) Then
            MsgBox " Invalid Count Number. "
            Exit Sub
        End If
    Next i
    
    Count = txtCount.Text
    strLen = Len(strDefault)
    ' copy default data string to data array
    For i = 1 To strLen
        strSend(i - 1) = AscB(Mid(strDefault, i, 1))
    Next i
    strSend(Len(strDefault)) = 0
    'send data routine
    For i = 1 To Count
        For j = 1 To strLen
            retSend = send(soc, strSend(j - 1), 1, 0)
            If retSend = SOCKET_ERROR Then
                MsgBox "Couldn't send data to remote Socket. Error: " & Err.LastDllError
            End If
        Next j
    Next i
    txtSend.Enabled = True
End Sub

Private Sub txtip1_Change()
Dim ip1 As Byte

    If txtip1.SelStart = 0 Then
        Exit Sub
    Else
        Selidx = txtip1.SelStart
    End If
    If Len(txtip1.Text) > 0 Then
        ip1 = Asc(Mid(txtip1.Text, txtip1.SelStart, 1))
        If ip1 < Asc(0) Or ip1 > Asc(9) Then
            txtip1.Text = Left(txtip1.Text, txtip1.SelStart - 1) & Right(txtip1.Text, Len(txtip1.Text) - txtip1.SelStart)
            txtip1.SelStart = Selidx - 1
        End If
    End If
End Sub
Private Sub txtip2_Change()
Dim ip2 As Byte

    If txtip2.SelStart = 0 Then
        Exit Sub
    Else
        Selidx = txtip2.SelStart
    End If
    If Len(txtip2.Text) > 0 Then
        ip2 = Asc(Mid(txtip2.Text, txtip2.SelStart, 1))
        If ip2 < Asc(0) Or ip2 > Asc(9) Then
            txtip2.Text = Left(txtip2.Text, txtip2.SelStart - 1) & Right(txtip2.Text, Len(txtip2.Text) - txtip2.SelStart)
            txtip2.SelStart = Selidx - 1
        End If
    End If
End Sub
Private Sub txtip3_Change()
Dim ip3 As Byte

    If txtip3.SelStart = 0 Then
        Exit Sub
    Else
        Selidx = txtip3.SelStart
    End If
    If Len(txtip3.Text) > 0 Then
        ip3 = Asc(Mid(txtip3.Text, txtip3.SelStart, 1))
        If ip3 < Asc(0) Or ip3 > Asc(9) Then
            txtip3.Text = Left(txtip3.Text, txtip3.SelStart - 1) & Right(txtip3.Text, Len(txtip3.Text) - txtip3.SelStart)
            txtip3.SelStart = Selidx - 1
        End If
    End If
End Sub
Private Sub txtip4_Change()
Dim ip4 As Byte

    If txtip4.SelStart = 0 Then
        Exit Sub
    Else
        Selidx = txtip4.SelStart
    End If
    If Len(txtip4.Text) > 0 Then
        ip4 = Asc(Mid(txtip4.Text, txtip4.SelStart, 1))
        If ip4 < Asc(0) Or ip4 > Asc(9) Then
            txtip4.Text = Left(txtip4.Text, txtip4.SelStart - 1) & Right(txtip4.Text, Len(txtip4.Text) - txtip4.SelStart)
            txtip4.SelStart = Selidx - 1
        End If
    End If
End Sub

Private Sub txtPort_Change()
Dim port As Byte
    
    If txtPort.SelStart = 0 Then
        Exit Sub
    Else
        Selidx = txtPort.SelStart
    End If
    If Len(txtPort.Text) > 0 Then
            port = Asc(Mid(txtPort.Text, txtPort.SelStart, 1))
            If port < Asc(0) Or port > Asc(9) Then
                txtPort.Text = Left(txtPort.Text, txtPort.SelStart - 1) & Right(txtPort.Text, Len(txtPort.Text) - txtPort.SelStart)
                txtPort.SelStart = Selidx - 1
            End If
    End If
End Sub

Private Sub txtCount_Change()
Dim cnt As Byte

    If txtCount.SelStart = 0 Then
        Exit Sub
    Else
        Selidx = txtCount.SelStart
    End If
    If Len(txtCount.Text) > 0 Then
        cnt = Asc(Mid(txtCount.Text, txtCount.SelStart, 1))
        If cnt < Asc(0) Or cnt > Asc(9) Then
            txtCount.Text = Left(txtCount.Text, txtCount.SelStart - 1) & Right(txtCount.Text, Len(txtCount.Text) - txtCount.SelStart)
            txtCount.SelStart = Selidx - 1
        End If
    End If
End Sub
