
#include	<stdio.h>
#include	<stdlib.h>
#include	"sio.h"

#define TEST_PORT_NO	2
#define TEST_SPEED	115200
#define TEST_FLOWCTRL	HW_FLOWCTRL
#define BUF_LEN		1024

char	rxbuf[BUF_LEN], txbuf[BUF_LEN];

int	main(int argc, char *argv[])
{
	int	i, txcnt[TEST_PORT_NO], rxcnt[TEST_PORT_NO];

	printf("Initialize the variable.\n");
	for ( i=0; i<BUF_LEN; i++ ) {
		txbuf[i] = i & 0xff;
	}
	printf("Initialize the serial port.\n");
	sio_init();
	for ( i=0; i<TEST_PORT_NO; i++ ) {
		txcnt[i] = rxcnt[i] = 0;
		sio_open(i);
		sio_baud(i, TEST_SPEED);
		sio_flowctrl(i, TEST_FLOWCTRL);
		sio_flush(i, FLUSH_INOUT);
	}
	printf("Starting to receive & transmit data ...\n");
	while ( 1 ) {
		for ( i=0; i<TEST_PORT_NO; i++ ) {
			txcnt[i] += sio_write(i, txbuf, BUF_LEN);
			rxcnt[i] += sio_read(i, rxbuf, BUF_LEN);
		}
	}
	return 0;
}
